/**************************************************************

File Name:		IIR_mctest.asm
		
Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1 Silicon
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SECTIONsyntax

Description:	ADSP-21364 multichannel SIMD program to call 
				CASCADE_MC.asm.  The coeficient, input and output 
				buffers are	interleaved.

**************************************************************/
#include "def21364.h"

.EXTERN cascaded_biquad, cascaded_biquad_init;
.GLOBAL coefs, dline;

#define SAMPLES 256
#define SECTIONS 3

.SECTION/DM    seg_dmda;
.VAR    inbuf[2*SAMPLES]= "indata1.dat";     /* input7.dat */
.VAR    outbuf[2*SAMPLES];                	/* ends up holding response */
.VAR    dline[2*SECTIONS*2];              	/* w``, w`, NEXT w``, NEXT w`, ... */


.SECTION/PM    seg_pmda;
.VAR    coefs[2*SECTIONS*4]="iircoefs_pey.dat";   /* a12,a11,b12,b11,a22,a21,... */


.SECTION/PM    seg_rth;
Reserved_1:		rti; nop; nop; nop;
Chip_Reset:		idle; jump begin; nop; nop;
	


.SECTION/PM    seg_pmco;
begin:  m1=2; 							/* modified for SIMD */
		m8=m1;
		l0=12; 							/* delay line circular buffer */
		l1=0;
 	    l3=0;
		l4=0;
		l8=24;
		r0=SECTIONS;
		r1=SAMPLES;						/* setup loop counter */
		r5=4*SECTIONS;
		b0=dline;
		call cascaded_biquad_init (db);     /* zero the delay line */
        b1=b0;
		b8=coefs;
filt:	call cascaded_biquad (db);      /* input=F8, output=F8 */
        b3=inbuf; 
		b4=outbuf;
done:   jump filt;
		nop;
		nop;

